#pragma once

struct S_CALLBACK
{
	std::wstring wcsCallback;
	std::wstring wcsMove;
};

// ---------------------------------------------------------------------------------
class CMyClass
{
public:
	CMyClass();
	~CMyClass();
	BOOL GetJSClass(JSClass** ppJSClass, JSPropertySpec** ppJSProps, JSFunctionSpec** ppJSMethods, void** ppPrivate);
	BOOL DocumentLoaded();
	void DocumentDestroy();
	void DeviceLost();
	void DeviceRestore();
	void Update(FLOAT seconds);
	void SetCallback(std::wstring wcsCallback, std::wstring sMove);

	bool NewGame();
	CHESSCOLOR GetCurrPlayer();
	bool MakeMove(char* pMove);
	bool GetMove(std::wstring wcsCallbackFunction);
	int GetStrength();
	void SetStrength(int iStrength);
	std::string GetValidMoves(char* pFrom);
	bool SetPositionsFEN(char* pPositions);
	std::string GetPositionsFEN(void);
	int GetCalcRunning(void);
	bool AbortThinking(void);
	bool IsValidMove(char* pMove);
	bool IsKingAttacked();
	int GetNumberOfPossibleMoves(void);
	bool GetMoveProposal(std::wstring wcsCallbackFunction);

private:	
	void RiseCallback();
	S_CALLBACK m_TheCallback;

};
// ---------------------------------------------------------------------------------

extern CMyClass myclass;
extern CMSCP mychess;

