//   myclass - script

#pragma warning(disable:4100)

#define RETURN_FALSE(msg) \
	{ GL_WriteDebugOut(msg); \
	  *rval = BOOLEAN_TO_JSVAL(JS_FALSE);\
	  return JS_TRUE; }

#define RETURN_TRUE \
	{ *rval = BOOLEAN_TO_JSVAL(JS_TRUE);\
	  return JS_TRUE; }

// ---------------------------------------------------------------------------------
JSBool generic_addProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_delProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_enumerate(JSContext *cx, JSObject *obj)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_resolve(JSContext *cx, JSObject *obj, jsval id)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
JSBool generic_convert(JSContext *cx, JSObject *obj, JSType type, jsval *vp)
// ---------------------------------------------------------------------------------
{
    return JS_TRUE;
}

// ---------------------------------------------------------------------------------
void generic_finalize(JSContext *cx, JSObject *obj)
// ---------------------------------------------------------------------------------
{
}

// ---------------------------------------------------------------------------------
static JSClass myclass_class = {
    MY_CLASS_NAME, JSCLASS_HAS_PRIVATE,
    generic_addProperty,  generic_delProperty,  generic_getProperty,  generic_setProperty,
    generic_enumerate,    generic_resolve,      generic_convert,      generic_finalize
};
// ---------------------------------------------------------------------------------

// ---------------------------------------------------------------------------------
static JSBool myclass_getMyIDString(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getMyIDString called.");
	
	// CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);
	
	EnterCriticalSection(g_pInfo->pJSCS); 

	JSString* jsStrMyID = JS_NewUCStringCopyN(cx, (jschar*) MY_ID_STRING, wcslen(MY_ID_STRING));
	*vp = STRING_TO_JSVAL(jsStrMyID);

	LeaveCriticalSection(g_pInfo->pJSCS); 
	
	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_setMyIDString(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_setMyIDString called.");
	
	// This can not be changed by the user. So, do nothing
	
	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_getStrength(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getStrength called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	*vp = INT_TO_JSVAL(myclass->GetStrength());

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_setStrength(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_setStrength called.");

	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	EnterCriticalSection(g_pInfo->pJSCS);

	if (JSVAL_IS_INT(*vp))
		myclass->SetStrength(JSVAL_TO_INT(*vp));
	else
	{
		jsdouble dbl;
		JS_ValueToNumber(cx, *vp, &dbl);
		myclass->SetStrength((int) ((double) dbl));
	}

	LeaveCriticalSection(g_pInfo->pJSCS);

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_getCalcRunning(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getStrength called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	*vp = INT_TO_JSVAL(myclass->GetCalcRunning());

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_setCalcRunning(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_setCalcRunning called.");
	
	// This can not be changed by the user. So, do nothing
	
	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSPropertySpec myclass_props[] = {
    {"sID_String",      0,      JSPROP_ENUMERATE, myclass_getMyIDString,  myclass_setMyIDString},
	{"iStrength",       1,      JSPROP_ENUMERATE, myclass_getStrength,    myclass_setStrength},
	{"iCalcRunning",    2,      JSPROP_ENUMERATE, myclass_getCalcRunning, myclass_setCalcRunning},
    {0}
};
// ---------------------------------------------------------------------------------

// ---------------------------------------------------------------------------------
static JSBool myclass_newgame(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_newgame called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if (myclass->NewGame()==false) RETURN_FALSE(L"myclass_newgame myclass->NewGame() failed. ERROR.")
	else RETURN_TRUE	
}

// ---------------------------------------------------------------------------------
static JSBool myclass_currplayer(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_currplayer called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if (myclass->GetCurrPlayer()==WHITE) *rval = INT_TO_JSVAL(0);
	else *rval = INT_TO_JSVAL(1);

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_makemove(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_makemove called.");

	if ((argc!=1)||(!JSVAL_IS_STRING(argv[0]))) RETURN_FALSE(L"myclass_makemove wrong arguments. ERROR.")
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	WCHAR* pMoveStringW = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	int iMoveStringLength = (int) JS_GetStringLength(JSVAL_TO_STRING(argv[0]));

	if (iMoveStringLength>10) RETURN_FALSE(L"myclass_makemove string too long. ERROR.")
	
	char pMoveString[20]; 
	memset(pMoveString,0,sizeof(pMoveString));

	wcstombs(pMoveString, pMoveStringW, sizeof(pMoveString)-1);

	if (myclass->MakeMove(pMoveString)==false) RETURN_FALSE(L"myclass_makemove. ERROR.")
	else RETURN_TRUE
}

// ---------------------------------------------------------------------------------
static JSBool myclass_requestmove(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_requestmove called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if ((argc != 1)||(!JSVAL_IS_STRING(argv[0])))
	{         
		GL_WriteDebugOut(L"myclass_requestmove: Wrong argument count or type. ERROR.");
		*rval = BOOLEAN_TO_JSVAL(JS_FALSE);
		return JS_TRUE;
    }

	WCHAR* pCallbackString = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	std::wstring sCallbackString(pCallbackString);
	
	if (myclass->GetMove(sCallbackString))  *rval = BOOLEAN_TO_JSVAL(JS_TRUE);
	else *rval = BOOLEAN_TO_JSVAL(JS_FALSE);
	
	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_getvalidmoves(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getvalidmoves called.");

	EnterCriticalSection(g_pInfo->pJSCS);

	if ((argc!=1)||(!JSVAL_IS_STRING(argv[0]))) 
	{
		GL_WriteDebugOut(L"myclass_getvalidmoves wrong arguments. ERROR.");
		JSString* jsMoveStr = JS_NewUCStringCopyN(cx, (jschar*) L"", wcslen(L""));
		*rval = STRING_TO_JSVAL(jsMoveStr);
		LeaveCriticalSection(g_pInfo->pJSCS);
		return JS_TRUE;
	}

	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	WCHAR* pMoveFromW = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	int iMoveFromLength = (int) JS_GetStringLength(JSVAL_TO_STRING(argv[0]));

	if (iMoveFromLength>2) 
	{
		GL_WriteDebugOut(L"myclass_getvalidmoves string too long. ERROR.");
		JSString* jsMoveStr = JS_NewUCStringCopyN(cx, (jschar*) L"", wcslen(L""));
		*rval = STRING_TO_JSVAL(jsMoveStr);
		LeaveCriticalSection(g_pInfo->pJSCS);
		return JS_TRUE;
	}
	
	char pMoveFrom[3]; 
	memset(pMoveFrom,0,sizeof(pMoveFrom));

	wcstombs(pMoveFrom, pMoveFromW, sizeof(pMoveFrom)-1);

	std::string sReturn = myclass->GetValidMoves(pMoveFrom);

	WCHAR* sReturnW = new WCHAR[sReturn.length()+1]; 
	wmemset(sReturnW,0,sReturn.length()+1);
	mbstowcs(sReturnW, sReturn.c_str(),sReturn.length());

	JSString* jsMoveStr = JS_NewUCStringCopyN(cx, (jschar*) sReturnW, wcslen(sReturnW));
	*rval = STRING_TO_JSVAL(jsMoveStr);

	LeaveCriticalSection(g_pInfo->pJSCS);

	delete[] sReturnW;

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_setpositionsfen(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_setpositionsfen called.");

	if ((argc!=1)||(!JSVAL_IS_STRING(argv[0]))) RETURN_FALSE(L"myclass_setpositionsfen wrong arguments. ERROR.")
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	WCHAR* pFENStringW = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	int iFENStringLength = (int) JS_GetStringLength(JSVAL_TO_STRING(argv[0]));

	if (iFENStringLength>1023) RETURN_FALSE(L"myclass_setpositionsfen string too long. ERROR.")

	char pFENString[1024]; 
	memset(pFENString,0,sizeof(pFENString));

	wcstombs(pFENString, pFENStringW, sizeof(pFENString)-1);

	if (myclass->SetPositionsFEN(pFENString)==false) RETURN_FALSE(L"myclass_setpositionsfen. ERROR.")
	else RETURN_TRUE
}

// ---------------------------------------------------------------------------------
static JSBool myclass_getpositionsfen(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getpositionsfen called.");

	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	std::string sReturn = myclass->GetPositionsFEN();

	WCHAR* sReturnW = new WCHAR[sReturn.length()+1]; 
	wmemset(sReturnW,0,sReturn.length()+1);
	mbstowcs(sReturnW, sReturn.c_str(),sReturn.length());

	EnterCriticalSection(g_pInfo->pJSCS);

	JSString* jsMoveStr = JS_NewUCStringCopyN(cx, (jschar*) sReturnW, wcslen(sReturnW));
	*rval = STRING_TO_JSVAL(jsMoveStr);

	LeaveCriticalSection(g_pInfo->pJSCS);

	delete[] sReturnW;

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_abortthinking(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_abortthinking called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if (myclass->AbortThinking()==false) RETURN_FALSE(L"myclass_newgame myclass->AbortThinking() failed. ERROR.")
	else RETURN_TRUE	
}

// ---------------------------------------------------------------------------------
static JSBool myclass_isvalidmove(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_isvalidmove called.");

	if ((argc!=1)||(!JSVAL_IS_STRING(argv[0]))) RETURN_FALSE(L"myclass_isvalidmove wrong arguments. ERROR.")
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	WCHAR* pMoveStringW = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	int iMoveStringLength = (int) JS_GetStringLength(JSVAL_TO_STRING(argv[0]));

	if (iMoveStringLength>10) RETURN_FALSE(L"myclass_isvalidmove string too long. ERROR.")
	
	char pMoveString[20]; 
	memset(pMoveString,0,sizeof(pMoveString));

	wcstombs(pMoveString, pMoveStringW, sizeof(pMoveString)-1);

	if (myclass->IsValidMove(pMoveString)==true) *rval = BOOLEAN_TO_JSVAL(JS_TRUE);
	else *rval = BOOLEAN_TO_JSVAL(JS_FALSE);

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_iskingattacked(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_iskingattacked called.");

	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if (myclass->IsKingAttacked()==true) *rval = BOOLEAN_TO_JSVAL(JS_TRUE);
	else *rval = BOOLEAN_TO_JSVAL(JS_FALSE);

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_getmovescount(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_getmovescount called.");

	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	*rval = INT_TO_JSVAL(myclass->GetNumberOfPossibleMoves());

	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSBool myclass_proposemove(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
// ---------------------------------------------------------------------------------
{
	GL_WriteDebugOut(L"myclass_proposemove called.");
	
	CMyClass* myclass=(CMyClass*) JS_GetPrivate(cx, obj);

	if ((argc != 1)||(!JSVAL_IS_STRING(argv[0])))
	{         
		GL_WriteDebugOut(L"myclass_proposemove: Wrong argument count or type. ERROR.");
		*rval = BOOLEAN_TO_JSVAL(JS_FALSE);
		return JS_TRUE;
    }

	WCHAR* pCallbackString = (WCHAR*) JS_GetStringChars(JSVAL_TO_STRING(argv[0]));
	std::wstring sCallbackString(pCallbackString);
	
	if (myclass->GetMoveProposal(sCallbackString))  *rval = BOOLEAN_TO_JSVAL(JS_TRUE);
	else *rval = BOOLEAN_TO_JSVAL(JS_FALSE);
	
	return JS_TRUE;
}

// ---------------------------------------------------------------------------------
static JSFunctionSpec myclass_methods[] = {
    {"NewGame",         myclass_newgame,		   0},
	{"GetCurrPlayer",   myclass_currplayer,	       0},
	{"MakeMove",        myclass_makemove,		   1},
	{"RequestMove",     myclass_requestmove,	   1},
	{"GetValidMoves",   myclass_getvalidmoves,	   1},
	{"SetPositionsFEN", myclass_setpositionsfen,   1},
	{"GetPositionsFEN", myclass_getpositionsfen,   0},
	{"AbortThinking",   myclass_abortthinking,     0},
	{"IsValidMove",     myclass_isvalidmove,       1},
	{"IsKingAttacked",  myclass_iskingattacked,    0},
	{"GetMovesCount",   myclass_getmovescount,     0},
	{"ProposeMove",     myclass_proposemove,	   1},
	{0}
};
// ---------------------------------------------------------------------------------

